# Debugging level, 0=errors only, 1=return status, init messages,
#   2=smtp server communication, 3=detailed smtp server communication,
#   4=tracebacks, 5=smtp client communication
#   Do not use debug level higher than 9!
DEBUG_LEVEL=4

LANG=['sk_SK']
LOCALE_DIR='/tmp/sagator/usr/local/share/locale'

# Where is new root path. For example '/var/spool/vscan'
CHROOT='/var/spool/vscan'

# Logfile (use logfile in chroot to allow rotating)
LOGFILE=CHROOT+'/var/log/sagator/sagator.log'

# User and group, under which this program runs.
USER,GROUP='vscan','vscan'

# SMTP server host and port. You must define this smtp server
# in postfix without filtering.
SMTP_SERVER=('127.0.0.1',26)

# Scanners and services
from scanners import *
from srv import *

DROP='(worm|@mm|Sobig|Klez|Bugbear|Gibe|Swen|Mimail|Sober|Bagle|Mydoom|Novarg|Lirva)'

from avlib import ascanner,mail,is_infected
import re

# Define scanners
SCANNERS=[
  #remove_headers('Received'),
  add_header('X-Loop', 'bonehead', const(0.0, 'XXX')),
#  log_syslog('ip=$SENTBY_IP, name=$SENTBY_NAME, helo=$SENTBY_HELO, recip=$RECIPIENTS, sender=$SENDER',
  log_mysql('127.0.0.1',3306,'sagator','root','sqlp1',log_mysql.FORMAT,
  #log_sqlite('/tmp/sagator.sqlite',log_sqlite.FORMAT,
  log(1,log.SUMMARY_REPORT,
    status("Virus",
#      report(['ondrejj@salstar.sk'],report.MSG_TMPL,
        quarantine('/tmp/quarantine/%Y%m','',
#          drop('.',
            # ClamAV
            #alternatives(
              #stream2file(libclam(limits={'maxratio':1000})),
              parsemail(s2f(libclam())),
#              mimeparse(s2f(libclam())),
              #parsemail(stream2file(decompress(libclam()))),
              #stream2file(decompress(libclam())),
              #clamd(['localhost',3310]),
#              clamd('/var/run/clamav/clamd.sock'),
              #stream2mbox(clamscan(['/usr/bin/clamscan','--stdout','--infected','--disable-summary','-r','--mbox'])),
            #),
            # Simple scanners
            #max_file_size(10),
            #parsemail(file_type({'exe': 'Executable'})),
            #string_scan(VIR_PATTERNS),
            #regexp_scan({'virname':['___PATTERN___']}),
            #mime_ext(mime_ext.EXECUTABLES),
            # AVG7 for linux
            #parsemail(s2f(avgd(chroot=CHROOT))),
            #parsemail(s2f(avgd())),
            # Bitdefender bdc
#            s2f(bdc(['/opt/bdc/bdc','--log=/tmp/bdc.log','--mail','--all','--arc'])),
            # NOD
            #parsemail(stream2file(decompress(nodold(['localhost',8448])))),
#            stream2mbox(nod2()),
#            stream2mbox(cmd_uvscan('/opt/uvscan/uvscan')),
            #nod2d('/tmp/dazuko/mb-','/var/log/nod32fac.log'),
            # Sophie
            #parsemail(s2f(decompress(sophie('/tmp/sophie',CHROOT)))),
            # exec any program
            #s2f(exec_any(['/bin/grep','-q','^TVqQ'],[1],[0])),
            # Kaspersky kav
#            stream2mbox(libclam()),
#            s2f(kavclient('/var/run/aveserver')),
#            s2f(kav()),
            # Symantec antivirus scan engine.
#            savse('localhost',1344),
#            parsemail(savse('localhost'))
#          )
        )
#      )
    ),
    status("Spam",
#      quarantine('/tmp/quarantine','',
#        drop('.', # drop all spams
#          dspam()
          #dspam_classify_spam()
          #dspam_classify_innocent()
          # SpamAssassin
          #alternatives(
            #(const(1.0)-max_file_size(200*1024)) &
            #modify_subject('[%V]', rename('SPAM:$LEVEL',
            spamassassind(['localhost',783]),
            #)),
          #  spamassassin(['/usr/bin/spamassassin','-e'])
          #),
#          bogofilter(['/usr/bin/bogofilter','-v']),
          #qsf(['/usr/bin/qsf','-r']),
#        )
      )
    )
  ),
#  filter(['/tmp/as/sanitizer.pl'])
  # forward special emails
  # forward special emails
  #deliver_to(['ondrejj@home.salstar.sk'],
  #  smtp_comm({'CRCZ':['MAIL FROM:.*test@tester.salxstar.sk']})
  #).onlyif('CRCZ')&const(0.0),
  #restore('firstpass')
]

#try:
#  SCANNERS=[
#    drop('.',
#      smtp_comm({'SPAM':['^RCPT TO:<spam@']})
#        & (dspam(classify=DSR_ISSPAM,source=DSS_ERROR,train=DST_TOE)
#           +const(1.0,'TRAINED')),
#      smtp_comm({'HAM':['^RCPT TO:<ham@']})
#        & (dspam(classify=DSR_ISINNOCENT,source=DSS_ERROR,train=DST_TOE)
#           +const(1.0,'TRAINED'))
#    ),
#    quarantine('/tmp/quarantine/%Y%m', '',
#      dspam()
#    )
#  ]
#except:
#  pass

ecce_SCANNERS=[ # ECCE
  # Check for marked message
  store('REALLY_CLEAN',
    rename('',regexp_scan({'':['^Subject: NOSPAM'],'&':['.']},-1))
  ) & const(0),
  # Check for viruses
  report(['root@localhost'],report.MSG_TMPL,
    quarantine('/tmp/quarantine/%Y%m','',
      drop(DROP,
        #stream2mbox(libclam(limits={'maxratio':1000})),
        restore('REALLY_CLEAN') & (
          parsemail(
            #file_magic({'Executable_magic': '/.*exec'},re.I),
            #file_type({'exe': 'Executable'}),
            attach_name({'Executable':'\.(exe|com|vxd|dll|cpl|scr|pif|lnk|bat|vbs|js)$'})
          ) | const(0)
        )
      )
    )
  ),
  # Check for spams
  quarantine('/tmp/quarantine/%Y%m','',
    # SPAMASSASSIN
    restore('REALLY_CLEAN') & spamassassind(['localhost',783])
  )
]

# Define services
SRV=[
  # statistics collector
  #collector('127.0.0.1',28),
  # resources
  rlimit(AS=100*MB),
  # SMTP daemon (for posfix etc.)
  #smtpd(SCANNERS,'0.0.0.0',2727,2),
  #smtpd([],'127.0.0.1',2727,2),
  # Milter daemon
  #milter(SCANNERS,"sagator","inet:3333@127.0.0.1")
  # Filter
  avfilter(SCANNERS)
  # http proxy
  #http_proxy(SCANNERS,'127.0.0.1',3128,2)
  # virtual web service
  #webq_apache(
  #  db='MySQLdb',
  #  host='localhost',port=3306,dbname='sagator',
  #  dbuser='root',dbpasswd='sqlp1',
  #  scanner=#match_any(s2f(libclam()),spamassassind(['localhost',783])),
  #    s2f(libclam()),
  #  userconv=('^(.*)$','"\\1"@localhost.bart.sk'),
  #  admin=['ondrejj']
  #)
]
